(function ($) {
  Drupal.behaviors.simple_package_tracking = {
    attach: function (context, settings) {
      var replacePat = Drupal.settings.simple_package_tracking.replacePat;
      var carriers = Drupal.settings.simple_package_tracking.carriers;
      var defaultUrl = '';
      var lastKey = '';
      if (carriers) {
        // Set up to point at the last carrier - which is most likely
        if (Object.keys) { // Skip logic if browser is too old.
          var keys = Object.keys(carriers);
          for (var key in keys) {
            lastKey = keys[key];
          }
          $('#edit-tracking-carrier').val(lastKey);
        }
      }

      $('#edit-tracking-carrier').change( function() {
	if ($(this).val() == 'new') {
	  $('.form-item-carrier-new').show();
	  $('.form-item-tracking-url').show();
	  $('#edit-carrier-new').focus();
	} else {
	  $('.form-item-carrier-new').hide();
	  $('.form-item-tracking-url').hide();
          $('#edit-tracking-number').focus();
	}
	$('#edit-carrier-url').change();
      });

      $('#edit-carrier-url').change( function() {
	$(this).val($('#edit-tracking-carrier').val());
	if ($(this).val() != 'new') {
	  defaultUrl = carriers[$(this).val()].url;
          $('#edit-tracking-url').val(defaultUrl);
	} else {
	  $('#edit-tracking-url').removeAttr('disabled');
	  $('#edit-tracking-url').val('');
	}
      });

      $('#edit-tracking-carrier').change();
      $('#edit-tracking-number').val('');
      $('.form-item-carrier-url').hide();

      // Fix a bug that a previous dropdown suggestion list reappears
      // after saving a tracking number.
      $('#edit-tracking-number').blur();
      $('#edit-tracking-number').focus();

      // For some reason if we don't remove the disabled attribute
      // from the #edit-tracking-url element, it won't submit its value
      // (Update: After adding AJAX, this doesn't appear to be necessary any more.)
      /*$('.simple-package-tracking-form .form-submit').click( function() {
	$('#edit-tracking-url').removeAttr('disabled');
      });*/
    }
  }
})(jQuery);
